/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago4q.extractors.script;

import it.eng.spago.base.SourceBean;
import it.eng.spago.configuration.ConfigSingleton;
import it.eng.spago.error.EMFErrorSeverity;
import it.eng.spago.error.EMFUserError;

import java.text.DateFormat;
import java.text.ParseException;

import java.text.SimpleDateFormat;
import java.util.Date;

public final class DateConverterScript {
	
	private DateConverterScript(){}

	public static String execute(final String date, final String format)
			throws EMFUserError {
 		DateFormat formatter = new SimpleDateFormat(format.trim());
		String toReturn = null;

		ConfigSingleton configSingleton = ConfigSingleton.getInstance();
		SourceBean dbFormatConfigSourceBean = (SourceBean) configSingleton
				.getFilteredSourceBeanAttribute(
						"SPAGO4Q.DB-DATE-FORMAT.FORMAT", "name", "format");
		String dBFormat = (String) dbFormatConfigSourceBean
				.getAttribute("formatconverter");
		try {
			Date inputDate = (Date) formatter.parse(date);
			formatter = new SimpleDateFormat(dBFormat);
			toReturn = formatter.format(inputDate);
		} catch (ParseException e) {
			throw new EMFUserError(EMFErrorSeverity.ERROR, e.getMessage());
		}
		return toReturn;
	}
}
