/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago4q.extractors.xml;

import it.eng.spago4q.extractors.bo.GenericItem;

import java.util.Iterator;

import org.dom4j.Element;
import org.dom4j.ElementHandler;
import org.dom4j.ElementPath;

public class SaxElementHandler implements ElementHandler{
	
	private SaxXmlExtractor extractor;

	public SaxElementHandler(final SaxXmlExtractor extractor) {
		this.extractor = extractor;
	}
	
	public void onEnd(final ElementPath path) {
		// process a ROW element
		Element row = path.getCurrent();
		GenericItem gi = new GenericItem();
		for (Iterator<Element> iterator = row.elementIterator(); iterator
				.hasNext();) {
			Element object = (Element) iterator.next();
			if (!object.getTextTrim().equals("")){
				gi.setValue(object.getName(), object.getTextTrim());
			}
		}
		extractor.setGenericItem(gi);
		// prune the tree
		row.detach();
	}

	public void onStart(final ElementPath path) {
	
	}
}