/**

  Spago4Q - The Business Intelligence Free Platform

  Copyright (C) 2009 Engineering Ingegneria Informatica S.p.A.

  Spago4Q is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  Spago4Q is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**/
package it.eng.spago4q.einterface.utils;

import it.eng.spago.base.SourceBean;
import it.eng.spago4q.bo.InterfaceField;
import it.eng.spago4q.bo.InterfaceType;
import it.eng.spago4q.utilities.DetailS4Q2ObjectUtil;

public class DetailEInterfaceFieldUtil extends DetailS4Q2ObjectUtil {

	private static final String DAO_NAME = "EInterfaceFieldDAO";
	private static final String OBJ_NAME = "EInterfaceField";

	@Override
	protected String getDAOName() {
		return DAO_NAME;
	}

	@Override
	protected Object getObjectFromRequest(SourceBean serviceRequest) {
		InterfaceField toReturn = new InterfaceField();
		String name = (String) serviceRequest.getAttribute("name");
		String fieldType = (String) serviceRequest.getAttribute("fieldType");
		String sensibileString = (String) serviceRequest
				.getAttribute("sensible");
		String keyFieldString = (String) serviceRequest
		.getAttribute("keyField");
		
		Boolean sensible = false;
		if (sensibileString != null) {
			sensible = true;
		}
		
		Boolean keyField = false;
		if (keyFieldString != null) {
			keyField = true;
		}

		String interfaceTypeId = (String) serviceRequest
				.getAttribute("Type_Id");

		toReturn.setName(name);
		toReturn.setFieldType(fieldType);
		toReturn.setSensible(sensible);
		toReturn.setKeyField(keyField);
		InterfaceType interfaceType = new InterfaceType();

		interfaceType.setId(Integer.parseInt(interfaceTypeId));

		toReturn.setInterfaceType(interfaceType);

		return toReturn;
	}

	@Override
	protected String getObjectName() {
		return OBJ_NAME;
	}

	@Override
	protected void setObjectId(Object object, Integer id) {
		((InterfaceField) object).setId(id);
	}
}
